#include "glwidget.h"

bool Button::MouseMove(float x, float y)
{
    FUNC("GLWidget::MouseMove");
    mpos = Vectorf(x, y);

    if(Within())
	focus = true;
    else
	focus = false;

    for(size_t i=0; i < children.size(); i++)
	children[i]->MouseMove(x, y);
    ENDRETURN(true);
}

bool Button::MouseClick(bool left, bool middle, bool right)
{
    FUNC("Button::MouseClick");

    if(focus && !lastleft)
	beenclicked = clicked = left;
    else
	focus = clicked = clicked && left;

    lastleft = left;
    lastmiddle = middle;
    lastright = right;
    ENDRETURN(false);
}

bool Button::Render()
{
    FUNC("Button::Render");
    assert(rendering);

    glLineWidth(theme->border);

    glPushMatrix();
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);
    glDisable(GL_TEXTURE_2D);
    glDisable(GL_DEPTH_TEST);

    if(clicked)
	glTranslatef(theme->clickoffset.x, theme->clickoffset.y, 0.0f);

    if(Text == "")
    {
	glEnable(GL_TEXTURE_2D);
	Tex.Bind();
    }

    glTranslatef(pos.x+dim.x/2, pos.y+dim.y/2, 0.0f);
    glPushMatrix();
    float dimx = dim.x, dimy = dim.y;
    for(int i=0; i < 2; i++)
    {
	if(i == 1)
	{
	    if(focus && theme->highlight)
	    {
		glColor3f((theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->bordercol.x,
			  (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->bordercol.y,
			  (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->bordercol.z);
	    }
	    else
	    {
		glColor3f((theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->bordercol.x,
			  (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->bordercol.y,
			  (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->bordercol.z);
	    }
	    glDisable(GL_TEXTURE_2D);
	    glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	}
	else
	{
	    if(focus && theme->highlight)
	    {
		glColor3f((theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->maincol.x,
			  (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->maincol.y,
			  (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->maincol.z);
	    }
	    else
	    {
		glColor3f((theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->maincol.x,
			  (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->maincol.y,
			  (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->maincol.z);
	    }
	    if(Text == "")
		glEnable(GL_TEXTURE_2D);
	    glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	}
	glBegin(GL_POLYGON);
	glTexCoord2f(0.0f, 0.0f);
	glVertex2f(-dimx/2, -dimy/2);
	glTexCoord2f(0.0f, (1.0f-theme->corner*3.0f));
	glVertex2f(-dimx/2, -dimy/2+dimy*(1.0f-theme->corner*3.0f));
	glTexCoord2f(theme->corner*3.0f, 1.0f);
	glVertex2f(-dimx/2+dimy*theme->corner*3.0f, -dimy/2+dimy);
	glTexCoord2f(1.0f, 1.0f);
	glVertex2f(-dimx/2+dimx, -dimy/2+dimy);
	glTexCoord2f(1.0f, theme->corner*3.0f);
	glVertex2f(-dimx/2+dimx, -dimy/2+dimy*theme->corner*3.0f);
	glTexCoord2f(1.0f, 0.0f);
	glVertex2f(-dimx/2+dimx-dimy*theme->corner*3.0f, -dimy/2);
	glTexCoord2f(0.0f, 0.0f);
	glVertex2f(-dimx/2, -dimy/2);
	glEnd();
    }
    glPopMatrix();
    glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);

    glColor3f(theme->textcol.x, theme->textcol.y, theme->textcol.z);
    glTranslatef(-dimx/2+theme->textsize.x/2, -dimy/2+theme->textsize.y/3.0f, 0.0f);
    font.Print(Text.c_str());

    glPopMatrix();

    ENDRETURN(true);
}
