#include "glwidget.h"

bool Optionbox::MouseClick(bool left, bool middle, bool right)
{
    FUNC("Optionbox::MouseClick");
    bool ret = false;
    if(focus && left && lastleft == false && !clicked)
    {
	clicked = true;
	clickdt = 1.0f;
	ret = true;
    }
    lastleft = left;
    lastmiddle = middle;
    lastright = right;
    ENDRETURN(ret);
}

bool Optionbox::SetFocussed(GLWidget *widget)
{
    FUNC("Optionbox::SetFocussed");
    if(clicked)
    {
	clickdt = 1.0f;
	clicked = false;
    }
    else
	clicked = false;
    ENDRETURN(true);
}

bool Optionbox::Render()
{
    FUNC("Optionbox::Render");
    assert(rendering);
    glPushMatrix();
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);
    glEnable(GL_TEXTURE_2D);
    glDisable(GL_DEPTH_TEST);
    theme->tex.Bind();

    if(focus && theme->highlight)
    {
	glColor3f((theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->maincol.x,
		  (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->maincol.y,
		  (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->maincol.z);
    }
    else
    {
	glColor3f((theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->maincol.x,
		  (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->maincol.y,
		  (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->maincol.z);
    }

    glBegin(GL_QUADS);
    glTexCoord2f(optionbox.x, optionbox.y);
    glVertex3f(pos.x,         pos.y,         0.0f);
    glTexCoord2f(optionbox.x, optionbox.w);
    glVertex3f(pos.x,         pos.y+theme->itemsize, 0.0f);
    glTexCoord2f(optionbox.z, optionbox.w);
    glVertex3f(pos.x+theme->itemsize, pos.y+theme->itemsize, 0.0f);
    glTexCoord2f(optionbox.z, optionbox.y);
    glVertex3f(pos.x+theme->itemsize, pos.y,         0.0f);
    glEnd();

    if(clicked || clickdt > 0.0001f)
    {
	if(clicked)
	    glColor4f(theme->brightfact*(1.0f-clickdt)*theme->maincol.x,
		      theme->brightfact*(1.0f-clickdt)*theme->maincol.y,
		      theme->brightfact*(1.0f-clickdt)*theme->maincol.z,
		      theme->brightfact*(1.0f-clickdt));
	else
	    glColor4f(theme->brightfact*clickdt*theme->maincol.x,
		      theme->brightfact*clickdt*theme->maincol.y,
		      theme->brightfact*clickdt*theme->maincol.z,
		      theme->brightfact*clickdt);

	glBegin(GL_QUADS);
	glTexCoord2f(optiondot.x, optiondot.y);
	glVertex3f(pos.x,         pos.y,         0.0f);
	glTexCoord2f(optiondot.x, optiondot.w);
	glVertex3f(pos.x,         pos.y+theme->itemsize, 0.0f);
	glTexCoord2f(optiondot.z, optiondot.w);
	glVertex3f(pos.x+theme->itemsize, pos.y+theme->itemsize, 0.0f);
	glTexCoord2f(optiondot.z, optiondot.y);
	glVertex3f(pos.x+theme->itemsize, pos.y,         0.0f);
	glEnd();
    }

    glColor3f(theme->textcol.x, theme->textcol.y, theme->textcol.z);
    glTranslatef(pos.x+theme->itemsize, pos.y+theme->itemsize/4.0f, 0.0f);
    font.Print((string(" ") + Text).c_str());

    glPopMatrix();
    ENDRETURN(true);
}
