#include "glwidget.h"

bool TabWindow::Render()
{
    FUNC("TabWindow::Render");
    glDisable(GL_DEPTH_TEST);
    glDisable(GL_TEXTURE_2D);
    glEnable(GL_BLEND);

    glPushMatrix();

    if(0 && Tex)
    {
	glEnable(GL_TEXTURE_2D);
	Tex->Bind();
    }
    else
	Tex = NULL;

    glTranslatef(pos.x+dim.x/2, pos.y+dim.y/2, 0.0f);

    glLineWidth(theme->border);
    float dimx = dim.x, dimy = dim.y;
    for(int i=0; i < 2; i++)
    {
	if(i == 1)
	{
	    if(focus && theme->highlight)
	    {
		glColor4f((theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->bordercol.x,
			  (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->bordercol.y,
			  (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->bordercol.z,
			  theme->mainalpha);
	    }
	    else
	    {
		glColor4f((theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->bordercol.x,
			  (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->bordercol.y,
			  (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->bordercol.z,
			  theme->mainalpha);
	    }
	    glDisable(GL_TEXTURE_2D);
	    glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	}
	else
	{
	    if(focus && theme->highlight)
	    {
		glColor4f((theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->maincol.x,
			  (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->maincol.y,
			  (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->maincol.z,
			  theme->mainalpha);
	    }
	    else
	    {
		glColor4f((theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->maincol.x,
			  (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->maincol.y,
			  (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->maincol.z,
			  theme->mainalpha);
	    }
	    if(Tex)
		glEnable(GL_TEXTURE_2D);
	    glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	}

	glBegin(GL_POLYGON);
	glTexCoord2f(0.0f, 0.0f);
	glVertex2f(-dimx/2, -dimy/2);
	glTexCoord2f(0.0f, (1.0f-theme->corner));
	glVertex2f(-dimx/2, -dimy/2+dimy*(1.0f-theme->corner));
	glTexCoord2f(theme->corner, 1.0f);
	glVertex2f(-dimx/2+dimy*theme->corner, -dimy/2+dimy);
	glTexCoord2f(1.0f, 1.0f);
	glVertex2f(-dimx/2+dimx, -dimy/2+dimy);
	glTexCoord2f(1.0f, theme->corner);
	glVertex2f(-dimx/2+dimx, -dimy/2+dimy*theme->corner);
	glTexCoord2f(1.0f, 0.0f);
	glVertex2f(-dimx/2+dimx-dimy*theme->corner, -dimy/2);
	glTexCoord2f(0.0f, 0.0f);
	glVertex2f(-dimx/2, -dimy/2);
	glEnd();
    }
    glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);

    glColor4f((theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->bordercol.x,
	      (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->bordercol.y,
	      (theme->brightfact*focusdt + theme->dimfact*(1.0f-focusdt))*theme->bordercol.z,
	      theme->mainalpha);

    glDisable(GL_TEXTURE_2D);

    glBegin(GL_LINES);
    glVertex2f(-dimx/2, -dimy/2+dimy-theme->textsize.y*2.0f);
    glVertex2f(-dimx/2+dimx, -dimy/2+dimy-theme->textsize.y*2.0f);
    glEnd();

    glPopMatrix();

    glPushMatrix();

    glColor3f(theme->textcol.x, theme->textcol.y, theme->textcol.z);

    tabs[currenttab].but->Focus();
    for(size_t i=0; i < tabs.size(); i++)
	tabs[i].but->Render();

    glPopMatrix();

    glPushMatrix();
    glTranslatef(pos.x+theme->insideborder*3.0f, pos.y+theme->insideborder*3.0f, 0.0f);
    for(size_t i=0; i < children.size(); i++)
    {
	glPushMatrix();
	if(children[i]->GetDepth() > -0.5f)
	    children[i]->Render();
	glPopMatrix();
    }
    for(size_t i=0; i < children.size(); i++)
    {
	glPushMatrix();
	if(children[i]->GetDepth() < -0.5f)
	    children[i]->Render();
	glPopMatrix();
    }

    glPopMatrix();
    ENDRETURN(true);
}

bool TabWindow::AddTab(int tab, string tabname)
{
    FUNC("TabWindow::AddTab");
    if((size_t)tab+1 > tabs.size())
	tabs.resize(tab+1);

    tabs[tab].name = tabname;
    if(tabs[tab].but)
	delete tabs[tab].but;
    tabs[tab].but = NULL;
    tabs[tab].children.clear();

    Vectorf start(0.0f, 0.0f);
    for(size_t i=0; i < tabs.size(); i++)
    {
	if(tabs[i].but)
	    delete tabs[i].but;

	ostringstream oss;
	oss << "__" << tag << "tab" << i << tabs[i].name;

	if(themes["tabwin_button.theme"] == NULL)
	{
	    themes["tabwin_button.theme"] = new Theme;
	    themes["tabwin_button.theme"]->Read("tabwin_button.theme");
	}

	tabs[i].but = new Button(oss.str(), this, start, themes["tabwin_button.theme"], tabs[i].name);

	start.x += tabs[i].but->Getbbox().z - tabs[i].but->Getbbox().x + 2.0f*theme->insideborder;
    }
    ENDRETURN(true);
}

bool TabWindow::AddToTab(int tab, GLWidget *wid)
{
    FUNC("TabWindow::AddToTab");
    if((size_t)tab+1 > tabs.size())
	tabs.resize(tab+1);
    if(tabs[tab].name == "")
	tabs[tab].name = "unnamed";
    tabs[tab].children.push_back(wid);
    AddChild(wid);

    float width = dim.y*theme->corner;
    for(size_t i=0; i < tabs.size(); i++)
	width += tabs[i].but->Getbbox().z - tabs[i].but->Getbbox().x + 2.0f*theme->insideborder;

    if(dim.x < width)
	dim.x = width;

    ENDRETURN(true);
}

bool TabWindow::Solidify()
{
    FUNC("TabWindow::Solidify");
    GLWindow::Solidify();
    children.clear();
    children = tabs[0].children;
    for(size_t i=0; i < tabs.size(); i++)
	(*tabs[i].but) += pos+Vectorf(dim.y*theme->corner,
				      dim.y-theme->textsize.y*1.75f);

    float width = dim.y*theme->corner;
    for(size_t i=0; i < tabs.size(); i++)
	width += tabs[i].but->Getbbox().z - tabs[i].but->Getbbox().x + 2.0f*theme->insideborder;

    if(dim.x < width)
	dim.x = width;
    ENDRETURN(true);
}

bool TabWindow::MouseMove(float x, float y)
{
    FUNC("TabWindow::MouseMove");

    for(size_t i=0; i < tabs.size(); i++)
	tabs[i].but->MouseMove(x, y);
    GLWindow::MouseMove(x, y);
    ENDRETURN(true);
}

bool TabWindow::MouseClick(bool left, bool middle, bool right)
{
    FUNC("TabWindow::MouseClick");
    GLWindow::MouseClick(left, middle, right);
    for(size_t i=0; i < tabs.size(); i++)
	tabs[i].but->MouseClick(left, middle, right);
    
    for(size_t i=0; i < tabs.size(); i++)
    {
	if(tabs[i].but->Clicked())
	{
	    children = tabs[i].children;
	    currenttab = i;
	}
    }
    ENDRETURN(true);
}

bool TabWindow::Update(int time)
{
    FUNC("TabWindow::Update");
    GLWidget::Update(time);
    for(size_t i=0; i < tabs.size(); i++)
	tabs[i].but->Update(time);
    ENDRETURN(true);
}

bool TabWindow::SetFocussed(GLWidget *widget)
{
    FUNC("TabWindow::SetFocussed");
    for(size_t i=0; i < children.size(); i++)
	children[i]->SetFocussed(widget);
    ENDRETURN(true);
}

