#include "light.h"

/*!
 * \file   light.cpp
 * \author  <baldurk@baldurk.org>
 * \date   Fri Feb  3 15:52:34 2006
 * 
 * \brief  Lighting details
 */

bool Light::init = false;
bool Light::light[GL_MAX_LIGHTS];

bool Light::Position(Vectorf pos, bool positional)
{
    FUNC("Light::Position");
    float posf[4];
    posf[0] = pos.x;posf[1] = pos.y;posf[2] = pos.z;
    if(positional)
	posf[3] = 1.0f;
    else
	posf[3] = 0.0f;
    glLightfv(Name, GL_POSITION, posf);
    ENDRETURN(true);
}

void Light::Direction(Vectorf dir)
{
    FUNC("Light::Direction");
    glLightfv(Name, GL_SPOT_DIRECTION, dir);
    END();
}

void Light::Ambient(Vectorf amb)
{
    FUNC("Light::Ambient");
    glLightfv(Name, GL_AMBIENT, amb);
    END();
}

void Light::Diffuse(Vectorf dif)
{
    FUNC("Light::Diffuse");
    glLightfv(Name, GL_DIFFUSE, dif);
    END();
}

void Light::Specular(Vectorf spec)
{
    FUNC("Light::Specular");
    glLightfv(Name, GL_SPECULAR, spec);
    END();
}

void Light::Attenuation(float constant, float linear, float quadratic)
{
    FUNC("Light::Attenuation");
    glLightf(Name, GL_CONSTANT_ATTENUATION, constant);
    glLightf(Name, GL_LINEAR_ATTENUATION, linear);
    glLightf(Name, GL_QUADRATIC_ATTENUATION, quadratic);
    END();
}
