// THIS FILE IS AUTOGENERATED BY message_gen. DO NOT EDIT DIRECTLY

#ifndef MESSAGES_H
#define MESSAGES_H

/*!
 * \file   messages.h
 * \author  <baldurk@baldurk.org>
 * \date   Mon Jan  2 23:37:07 2006
 * 
 * \brief  autogenerated file to define the messages and their masks  
 */

//! The value of the first message. So that the messages are offset
#define MSGFirstMessage      0x0010
/*! 
 * This message is sent/received when an object should load its resources from 
 * files. Specifically when they can be loaded without any dependencies. There 
 * will be another message later for loading resources dependant on the 
 * application having loaded (e.g. loading a texture).  
 */
#define MSGLoadResources     0x0000 + MSGFirstMessage
//! This message is sent when the window should be opened, or has been opened.
#define MSGOpenWindow        0x0001 + MSGFirstMessage
/*! 
 * This message is sent when resources should be loaded when the application has 
 * been partially started. Specifically loading textures and things.  
 */
#define MSGLoadGFXResources  0x0002 + MSGFirstMessage
/*! 
 * This messages is for the initial set up getting things into place - no loading 
 * should be done at this point, only setting the initial conditions.  
 */
#define MSGInitialSetup      0x0003 + MSGFirstMessage
/*! 
 * This message is for updating the gamestate by one tick. This should not involve 
 * rendering.  
 */
#define MSGUpdate            0x0004 + MSGFirstMessage
//! This message is to indicate there should be rendering.
#define MSGRender            0x0005 + MSGFirstMessage
//! The mouse should be moved.
#define MSGMouseMove         0x0006 + MSGFirstMessage
//! The mouse has been moved or clicked.
#define MSGMouse             0x0007 + MSGFirstMessage
//! A key has been pressed or released.
#define MSGKey               0x0008 + MSGFirstMessage
//! The window is being closed.
#define MSGCloseWindow       0x0009 + MSGFirstMessage
//! All resources should be released.
#define MSGReleaseResources  0x000A + MSGFirstMessage

////////////////////////////////////////////////////
//! number of masks
////////////////////////////////////////////////////
#define NumMasks             9

//! The ID for MASKResources
#define MASKResourcesID     0x0000
//! A mask for MSGLoadResources and MSGReleaseResources.
#define MASKResources       (1      <<  MASKResourcesID)     

//! The ID for MASKWindow
#define MASKWindowID        0x0001
//! A mask for MSGOpenWindow and MSGCloseWindow.
#define MASKWindow          (1      <<  MASKWindowID)        

//! The ID for MASKGFXResources
#define MASKGFXResourcesID  0x0002
//! A mask for MSGLoadGFXResources and MSGReleaseResources.
#define MASKGFXResources    (1      <<  MASKGFXResourcesID)  

//! The ID for MASKInitialSetup
#define MASKInitialSetupID  0x0003
//! A mask for MSGInitialSetup.
#define MASKInitialSetup    (1      <<  MASKInitialSetupID)  

//! The ID for MASKUpdate
#define MASKUpdateID        0x0004
//! A mask for MSGUpdate.
#define MASKUpdate          (1      <<  MASKUpdateID)        

//! The ID for MASKRender
#define MASKRenderID        0x0005
//! A mask for MSGRender.
#define MASKRender          (1      <<  MASKRenderID)        

//! The ID for MASKMouse
#define MASKMouseID         0x0006
//! A mask for MSGMouse.
#define MASKMouse           (1      <<  MASKMouseID)         

//! The ID for MASKMouseMove
#define MASKMouseMoveID     0x0007
//! A mask for MSGMouseMove.
#define MASKMouseMove       (1      <<  MASKMouseMoveID)     

//! The ID for MASKKeyboard
#define MASKKeyboardID      0x0008
//! A mask for MSGKey.
#define MASKKeyboard        (1      <<  MASKKeyboardID)      

#endif
